<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 04/11/19
 * Time: 8.56
 */

namespace FiloBlu\Rma\Helper;
use Magento\Framework\ObjectManagerInterface;

class SerializerHelper
{
    /**
     * @var ObjectManagerInterface
     */
    protected $objectManager;

    /**
     * SerializerHelper constructor.
     * @param ObjectManagerInterface $objectManager
     */
    public function __construct(ObjectManagerInterface $objectManager){
        $this->objectManager = $objectManager;
    }

     /**
     * @param $data
     * @return mixed
     */
    public function unserialize($data){
        if ($this->isSerialized($value)) {
            $unserializer = $this->objectManager->get(\Magento\Framework\Unserialize\Unserialize::class);
        } else {
            $unserializer = $this->objectManager->get(\Magento\Framework\Serialize\Serializer\Json::class);
        }

        return $unserializer->unserialize($value);
    }

    /**
     * @param $value
     * @return bool
     */
    protected function isSerialized($value)
    {
        return (boolean) preg_match('/^((s|i|d|b|a|O|C):|N;)/', $value);
    }

}